#chd.r
#risk of a coronary event from eight variables
rm(list=ls())

chd.in <- read.table("~/Dropbox/r-case.studies/chd.data",header=TRUE)
attach(chd.in)

#some useful tables
table(ab,chd)
smk0 <- findInterval(smk,c(1,10,20,30,99))
table(chd,smk0)
table(chd,smk0,ab)

D <- cbind(age,ht,wt,sys,dia,chol,smk,ab)
#Correlation array
round(cor(D),3)

#Correlation of chd with covariables
round(cor(chd,D),3)

#logistic additive regression model
f <- glm(chd~age+ht+wt+sys+dia+chol+smk+ab,family=binomial)
summary(f)
b.hat <- summary(f)$coefficients[,1][-1]
z <- summary(f)$coefficients[,3][-1]
pvalue <- summary(f)$coefficients[,4][-1]
rank.z <- rank(z)
or <- exp(b.hat) 
rank.or <- rank(or)
#Estimated Coefficients
round(cbind(b.hat,z,rank.z),3)
#Estimated p-values
round(cbind(z,pvalue),3)
#Estimated odds ratio
round(cbind(or,rank.or),3)
fact <- c(11,87,36,64,34,1)
OR <- or[c(-2,-5)]
OR.fact <- OR^fact
#Estimated odds ratio -- risk level to achieve or = 2
round(cbind(OR,fact,OR.fact),3)

