#cox.r 
library(survival)
rm(list=ls())
ci <- function(m,v) {
A <- m-1.960*sqrt(v)
B <- m+1.960*sqrt(v)
round(cbind(A,B),5) }

cox <- read.table("~/Dropbox/r-case.studies/cox.data",header=TRUE)
attach(cox)
summary(cox)

#chd coded -- CD4<700 = 0 CD4>=700 = 1
#cbind(t,cc,beta,cd4,age)

round(cor(cbind(cc,cd4,beta,age)),3)
round(cor(t,cbind(cd4,beta,age)),3)
#censored = 0 and complete = 1
table(cc)

fit <- coxph(Surv(t,cc)~cd4)
summary(fit) 
log.0 <- fit$loglik

fit1 <- coxph(Surv(t[cd4<600],cc[cd4<600])~cd4[cd4<600])
fit2 <- coxph(Surv(t[600<=cd4 & cd4<900],cc[600<=cd4 & cd4<900])~cd4[600<=cd4& cd4<900])
fit3 <- coxph(Surv(t[cd4>900],cc[cd4>900])~cd4[cd4>900])

#sample size, coefficient, standard error and confidence interval

round(cbind(fit1$n,fit1$coefficient,sqrt(fit1$var),
ci(fit1$coefficient,fit1$var)),3)
round(cbind(fit2$n,fit2$coefficient,sqrt(fit2$var),
ci(fit2$coefficient,fit2$var)),3)
round(cbind(fit3$n,fit3$coefficient,sqrt(fit3$var),
ci(fit3$coefficient,fit3$var)),3)

#quadratic
cd4.2 <- cd4^2
fit <- coxph(Surv(t,cc)~cd4+cd4.2)
summary(fit)
log.1 <- fit$loglik
X2 <- 2*(log.1-log.0)
pvalue <- 1-pchisq(X2,2)
round(cbind(log.1,X2,pvalue),3)

#cubic
cd4.3 <- cd4^3
fit <- coxph(Surv(t,cc)~cd4+cd4.2+cd4.3)
log.2 <- fit$loglik
X2 <- 2*(log.2-log.1)
pvalue <- 1-pchisq(X2,3)
round(cbind(log.2,X2,pvalue),3)
round(cbind(log.0[2],log.1[2],log.2[2]),2)


#additivity versus interaction
fit0 <- coxph(Surv(t,cc)~cd4+beta+age)
summary(fit0)
fit1 <- coxph(Surv(t,cc)~(cd4+beta+age)^2)
summary(fit1)
anova(fit0,fit1,test="Chisq")

