#gain.r
rm(list=ls())

gain <- read.table("~/Dropbox/r-case.studies/gain.data",header=TRUE) 
attach(gain)
y <- cbind(cat1,cat2,cat3,cat4,cat5)
summary(y)

# six summary values
round(apply(y,2,min),3)
round(apply(y,2,max),3)
round(apply(y,2,var),3)
round(apply(y,2,mean),3)
round(apply(y,2,median),3)
round(apply(y,2,var),3)

#Bartlett test of variance
k <- 5
n <- 150
N <- n*k
id <- sort(rep(1:k,n))
bartlett.test(as.vector(y)~id)
v <- apply(y,2,var)
vw <- (n-1)*sum(v)/(N-k)
vb <- (n-1)*sum(log(v))
c <- 1+(1/(3*(k-1)))*(k/(n-1)-1/(N-k))
X2 <- ((N-k)*log(vw)-sum(vb))/c
round(cbind(X2,1-pchisq(X2,4)),3)

#Levene test of variance
l.in <- function(x) {abs(x-mean(x))}
yy <- apply(y,2,l.in)
round(tapply(yy,id,mean),3)
y0 <- as.vector(yy)
summary(aov(y0~factor(id)))

# alternative summary test values for Levene.test
fit <- lm(y0~factor(id))
temp <- summary(fit)$fstatistic
F <- temp[1]
pvalue <- 1-pf(F,temp[2],temp[3])
round(cbind(F,pvalue),4)


