#gain.var.r
rm(list=ls())
#data:
data.in <- read.table("~/Dropbox/r-case.studies/gain.data",header=TRUE) 
attach(data.in)
y <- cbind(cat1,cat2,cat3,cat4,cat5)
vv <- function(y.in) { abs(y.in-mean(y.in)) }
id <- sort(rep(1:5,150))

#Levene test of equal variances
round(tapply(y,id,mean),3)
round(tapply(y,id,var),3)
yy <- apply(y,2,vv)
round(apply(yy,2,mean),3)
y0 <- as.vector(yy)
summary(aov(y0~factor(id)))

#alternative -- linear model
fit <- lm(y0~factor(id))
f <- summary(fit)$fstatistic
pvalue <- 1-pf(f[1],f[2],f[3])
F <- f[1]
round(cbind(F,pvalue),3)

#Bartlett.test test of equal variances
k <- 5
n <- 150
N <- 750
v <- apply(y,2,var)
vw <- (n-1)*sum(v)/(N-k)
vb <- (n-1)*sum(log(v))
c <- 1+(1/(3*(k-1)))*(k/(n-1)-1/(N-k))
X2 <- ((N-k)*log(vw)-sum(vb))/c
cbind(X2,1-pchisq(X2,4))
bartlett.test(as.vector(y)~id)
