
#spl.r -- analysis sound pressure and blood pressure
rm(list=ls())

#hypertention data from factor workers
temp <- read.table("~/Dropbox/r-case.studies/spl.data",header=TRUE)
attach(temp)

#correlation array
round(cor(cbind(bp,age,yrswork,hist,salt,spl)),2)

f <- glm(bp~spl,family=binomial)
summary(f)
f <- glm(bp~spl+age+yrswork+salt+hist,family=binomial)
summary(f)
#odds ratios
round(exp(coef(f)[-1]),2)

#close to collinear
cor(age,yrswork)
b.all <- coef(f)
l.all <- f$deviance/2
#age removed
f <- glm(bp~spl+yrswork+salt+hist,family=binomial)
b.age <- coef(f)
l.age <- f$deviance/2
#yrswork removed
f <- glm(bp~spl+age+salt+hist,family=binomial)
b.yrs <- coef(f)
l.yrs <- f$deviance/2

#summary of influence age/yrswork variables
#coefficients
#age and yrswork included
round(cbind(b.all),3)
#age removed
round(cbind(b.age),3)
#yrswork removed
round(cbind(b.yrs),3)

#log-likelihood values
round(cbind(l.all),3)
round(cbind(l.age),3)
round(cbind(l.yrs),3)


